Arch Check: Difference between revisions

From FreeCAD Documentation
m (docnav)
(Marked this version for translation)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>
<!--T:10-->
{{docnav|[[Arch_MergeWalls|Merge Walls]]|[[Arch_IfcExplorer|Ifc Explorer]]|[[Arch_Module|Arch]]}}
{{docnav|[[Arch_MergeWalls|Merge Walls]]|[[Arch_IfcExplorer|Ifc Explorer]]|[[Arch_Module|Arch]]}}


Line 38: Line 39:
** Each element in {{incode|list_bad}} is another list {{incode|[object, message]}}, where {{incode|object}} is the detected non-solid, and {{incode|message}} indicates the reason why it was included in this list.
** Each element in {{incode|list_bad}} is another list {{incode|[object, message]}}, where {{incode|object}} is the detected non-solid, and {{incode|message}} indicates the reason why it was included in this list.


<!--T:11-->
Example:
Example:
{{Code|code=
{{Code|code=
import FreeCAD, Draft, Arch
import FreeCAD, Draft, Arch


<!--T:12-->
p1 = FreeCAD.Vector(0, 0, 0)
p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(2000, 0, 0)
p2 = FreeCAD.Vector(2000, 0, 0)
Line 48: Line 51:
FreeCAD.ActiveDocument.recompute()
FreeCAD.ActiveDocument.recompute()


<!--T:13-->
Wall2 = Arch.makeWall(None, length=2000, width=200, height=1000)
Wall2 = Arch.makeWall(None, length=2000, width=200, height=1000)
FreeCAD.ActiveDocument.recompute()
FreeCAD.ActiveDocument.recompute()


<!--T:14-->
Circle = Draft.makeCircle(450)
Circle = Draft.makeCircle(450)
Wire = Draft.makeWire([FreeCAD.Vector(1000, 0, 0), FreeCAD.Vector(1500, 1000, 0), FreeCAD.Vector(2500, -1000, 0)])
Wire = Draft.makeWire([FreeCAD.Vector(1000, 0, 0), FreeCAD.Vector(1500, 1000, 0), FreeCAD.Vector(2500, -1000, 0)])


<!--T:15-->
list_bad = Arch.check([Wall1, Wall2, Circle, Wire], includehidden=True)
list_bad = Arch.check([Wall1, Wall2, Circle, Wire], includehidden=True)
print(list_bad)
print(list_bad)
}}
}}


<!--T:16-->
{{docnav|[[Arch_MergeWalls|Merge Walls]]|[[Arch_IfcExplorer|Ifc Explorer]]|[[Arch_Module|Arch]]}}
{{docnav|[[Arch_MergeWalls|Merge Walls]]|[[Arch_IfcExplorer|Ifc Explorer]]|[[Arch_Module|Arch]]}}



Revision as of 13:09, 5 February 2019

Arch Check

Menu location
Arch → Utilities → Check
Workbenches
Arch
Default shortcut
None
Introduced in version
-
See also
Arch CloseHoles

Description

This tool checks the current document or the selected objects for non-solid Part or Arch objects, that might give problems, since most operations of the Arch module require solid objects.

How to use

  1. Press the Check entry in Arch → Utilities → Check.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

This tool can be used in macros and from the Python console by using the following function:

list_bad = check(objectslist, includehidden=False)
  • Checks if the given objects in objectslist contain only solids.
  • If includehidden is True it will include all hidden objects, otherwise it will omit them from the search.
  • Returns list_bad, a list with the objects that are not derived from a Part::Feature, or components that are not closed, not valid, don't contain solids, or that contain faces that are not part of any solid. This is used to detect Arch or Draft wires and profiles that aren't solids.
    • Each element in list_bad is another list [object, message], where object is the detected non-solid, and message indicates the reason why it was included in this list.

Example:

import FreeCAD, Draft, Arch

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(2000, 0, 0)
baseline = Draft.makeLine(p1, p2)
Wall1 = Arch.makeWall(baseline, length=None, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()

Wall2 = Arch.makeWall(None, length=2000, width=200, height=1000)
FreeCAD.ActiveDocument.recompute()

Circle = Draft.makeCircle(450)
Wire = Draft.makeWire([FreeCAD.Vector(1000, 0, 0), FreeCAD.Vector(1500, 1000, 0), FreeCAD.Vector(2500, -1000, 0)])

list_bad = Arch.check([Wall1, Wall2, Circle, Wire], includehidden=True)
print(list_bad)